Difference between revisions of "Code snippets"

From FreeCAD Documentation
Jump to: navigation, search
Line 66: Line 66:
 
doc=App.activeDocument()  
 
doc=App.activeDocument()  
 
# add a line element to the document and set its points  
 
# add a line element to the document and set its points  
l=Part.line()
+
l=Part.Line()
l.setStartPoint((0.0,0.0,0.0))
+
l.StartPoint=(0.0,0.0,0.0)
l.setEndPoint((1.0,1.0,1.0))
+
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Line","Line").Line_=l  
+
doc.addObject("Part::Feature","Line").Shape=l.toShape()
 
doc.recompute()
 
doc.recompute()
 
</code>
 
</code>
Line 98: Line 98:
 
doc=App.activeDocument()  
 
doc=App.activeDocument()  
 
grp=doc.addObject("App::DocumentObjectGroup", "Group")  
 
grp=doc.addObject("App::DocumentObjectGroup", "Group")  
lin=doc.addObject("Part::Line", "Line")
+
lin=doc.addObject("Part::Feature", "Line")
 
grp.addObject(lin) # adds the lin object to the group grp
 
grp.addObject(lin) # adds the lin object to the group grp
 
grp.removeObject(lin) # removes the lin object from the group grp
 
grp.removeObject(lin) # removes the lin object from the group grp
Line 137: Line 137:
 
import Part
 
import Part
 
doc = App.activeDocument()
 
doc = App.activeDocument()
c = Part.circle() # create a circle object with undefined radius
+
c = Part.Circle()  
c.setRadius(10)  
+
c.Radius=10.0  
f = doc.addObject("Part::Circle", "Circle") # create a document with a circle feature  
+
f = doc.addObject("Part::Feature", "Circle") # create a document with a circle feature  
f.Circ = c # Assign the circle object to the Circ property  
+
f.Shape = c.toShape() # Assign the circle shape to the shape property  
 
doc.recompute()
 
doc.recompute()
 
</code>
 
</code>

Revision as of 14:59, 3 July 2008

This page contains examples, pieces, chunks of FreeCAD python code collected from users experiences and discussions on the forums. Read and use it as a start for your own scripts...


A typical InitGui.py file

Every module must contain, besides your main module file, an InitGui.py file, responsible for inserting the module in the main Gui. This is an example of a simple one.

class ScriptWorkbench (Workbench):

   MenuText = "Scripts"
   def Initialize(self):
       import Scripts # assuming Scripts.py is your module
       list = ["Script_Cmd"] # That list must contain command names, that can be defined in Scripts.py
       self.appendToolbar("My Scripts",list) 
       
       
       

Gui.addWorkbench(ScriptWorkbench())

A typical module file

This is an example of a main module file, containing everything your module does. It is the Scripts.py file invoked by the previous example. You can have all your custom commands here.

import FreeCAD, FreeCADGui

class ScriptCmd:

   def Activated(self): 
       # Here your write what your ScriptCmd does...
       FreeCAD.Console.PrintMessage('Hello, World!')
   def GetResources(self): 
       return {'Pixmap' : 'path_to_an_icon/myicon.png', 'MenuText': 'Short text', 'ToolTip': 'More detailed text'} 
   
   

FreeCADGui.addCommand('Script_Cmd', ScriptCmd())

Import a new filetype

Making an importer for a new filetype in FreeCAD is easy. FreeCAD doesn't consider that you import data in an opened document, but rather that you simply can directly open the new filetype. So what you need to do is to add the new file extension to FreeCAD's list of known extensions, and write the code that will read the file and create the FreeCAD objects you want:

This line must be added to the InitGui.py file to add the new file extension to the list:


  1. Assumes Import_Ext.py is the file that has the code for opening and reading .ext files

FreeCAD.EndingAdd("Your new File Type (*.ext)","Import_Ext")

Then in the Import_Ext.py file:

def open(filename):

   doc=App.newDocument()
   # here you do all what is needed with filename, read, classify data, create corresponding FreeCAD objects
   doc.recompute()

Adding a line

A line simply has 2 points.

import Part,PartGui doc=App.activeDocument()

  1. add a line element to the document and set its points

l=Part.Line() l.StartPoint=(0.0,0.0,0.0) l.EndPoint=(1.0,1.0,1.0) doc.addObject("Part::Feature","Line").Shape=l.toShape() doc.recompute()

Adding a polygon

A polygon is simply a set of connected line segments (a polyline in AutoCAD). It doesn't need to be closed.

import Part,PartGui doc=App.activeDocument() n=list()

  1. create a 3D vector, set its coordinates and add it to the list

v=App.Vector(0,0,0) n.append(v) v=App.Vector(10,0,0) n.append(v)

  1. ... repeat for all nodes
  2. Create a polygon object and set its nodes

p=doc.addObject("Part::Polygon","Polygon") p.Nodes=n doc.recompute()

Adding and removing an object to a group

doc=App.activeDocument() grp=doc.addObject("App::DocumentObjectGroup", "Group") lin=doc.addObject("Part::Feature", "Line") grp.addObject(lin) # adds the lin object to the group grp grp.removeObject(lin) # removes the lin object from the group grp

Note: You can even add other groups to a group...

Adding a Mesh

import Mesh doc=App.activeDocument()

  1. create a new empty mesh

m = Mesh.Mesh()

  1. build up box out of 12 facets

m.addFacet(0.0,0.0,0.0, 0.0,0.0,1.0, 0.0,1.0,1.0) m.addFacet(0.0,0.0,0.0, 0.0,1.0,1.0, 0.0,1.0,0.0) m.addFacet(0.0,0.0,0.0, 1.0,0.0,0.0, 1.0,0.0,1.0) m.addFacet(0.0,0.0,0.0, 1.0,0.0,1.0, 0.0,0.0,1.0) m.addFacet(0.0,0.0,0.0, 0.0,1.0,0.0, 1.0,1.0,0.0) m.addFacet(0.0,0.0,0.0, 1.0,1.0,0.0, 1.0,0.0,0.0) m.addFacet(0.0,1.0,0.0, 0.0,1.0,1.0, 1.0,1.0,1.0) m.addFacet(0.0,1.0,0.0, 1.0,1.0,1.0, 1.0,1.0,0.0) m.addFacet(0.0,1.0,1.0, 0.0,0.0,1.0, 1.0,0.0,1.0) m.addFacet(0.0,1.0,1.0, 1.0,0.0,1.0, 1.0,1.0,1.0) m.addFacet(1.0,1.0,0.0, 1.0,1.0,1.0, 1.0,0.0,1.0) m.addFacet(1.0,1.0,0.0, 1.0,0.0,1.0, 1.0,0.0,0.0)

  1. scale to a edge langth of 100

m.scale(100.0)

  1. add the mesh to the active document

me=doc.addObject("Mesh::Feature","Cube") me.Mesh=m

Adding an arc or a circle

import Part doc = App.activeDocument() c = Part.Circle() c.Radius=10.0 f = doc.addObject("Part::Feature", "Circle") # create a document with a circle feature f.Shape = c.toShape() # Assign the circle shape to the shape property doc.recompute()

Accessing and changing representation of an object

Each object in a FreeCAD document has an associated view representation object that stores all the parameters that define how the object appear, like color, linewidth, etc...

gad=Gui.activeDocument() # access the active document containing all

                          # view representations of the features in the
                          # corresponding App document 

v=gad.getObject("Cube") # access the view representation to the Mesh feature 'Cube' v.ShapeColor # prints the color to the console v.ShapeColor=(1.0,1.0,1.0) # sets the shape color to white

Observing mouse events in the 3D viewer via Python

The Inventor framework allows to add one or more callback nodes to the scenegraph of the viewer. By default in FreeCAD one callback node is installed per viewer which allows to add global or static C++ functions. In the appropriate Python binding some methods are provided to make use of this technique from within Python code.

App.newDocument() v=Gui.activeDocument().activeView()

  1. This class logs any mouse button events. As the registered callback function fires twice for 'down' and
  2. 'up' events we need a boolean flag to handle this.

class ViewObserver:

   def logPosition(self, info):
       down = (info["State"] == "DOWN")
       pos = info["Position"]
       if (down):
           FreeCAD.Console.PrintMessage("Clicked on position: ("+str(pos[0])+", "+str(pos[0])+")\n")
   
   

o = ViewObserver() c = v.addEventCallback("SoMouseButtonEvent",o.logPosition)

Now, pick somewhere on the area in the 3D viewer and observe the messages in the output window. To finish the observation just call

v.removeEventCallback("SoMouseButtonEvent",c)

The following event types are supported

  • SoEvent -- all kind of events
  • SoButtonEvent -- all mouse button and key events
  • SoLocation2Event -- 2D movement events (normally mouse movements)
  • SoMotion3Event -- 3D movement events (normally spaceball)
  • SoKeyboradEvent -- key down and up events
  • SoMouseButtonEvent -- mouse button down and up events
  • SoSpaceballButtonEvent -- spaceball button down and up events

The Python function that can be registered with addEventCallback() expects a dictionary. Depending on the watched event the dictionary can contain different keys.

For all events it has the keys:

  • Type -- the name of the event type i.e. SoMouseEvent, SoLocation2Event, ...
  • Time -- the current time as string
  • Position -- a tuple of two integers, mouse position
  • ShiftDown -- a boolean, true if Shift was pressed otherwise false
  • CtrlDown -- a boolean, true if Ctrl was pressed otherwise false
  • AltDown -- a boolean, true if Alt was pressed otherwise false

For all button events, i.e. keyboard, mouse or spaceball events

  • State -- A string 'UP' if the button was up, 'DOWN' if it was down or 'UNKNOWN' for all other cases

For keyboard events:

  • Key -- a character of the pressed key

For mouse button event

  • Button -- The pressed button, could be BUTTON1, ..., BUTTON5 or ANY

For spaceball events:

  • Button -- The pressed button, could be BUTTON1, ..., BUTTON7 or ANY

And finally motion events:

  • Translation -- a tuple of three floats
  • Rotation -- a quaternion for the rotation, i.e. a tuple of four floats

Manipulate the scenegraph in Python

It is also possible to get and change the scenegraph in Python. Therefore you have to have the 'pivy' module -- a Python binding for Coin.

from pivy.coin import * # load the pivy module view = Gui.ActiveDocument.ActiveView # get the active viewer root = view.getSceneGraph() # the root is an SoSeparator node root.addChild(SoCube()) view.fitAll()

The Python API of pivy is created by using the tool SWIG. As we use in FreeCAD some self-written nodes you cannot create them directly in Python. However, it is possible to create a node by its internal name. An instance of the type 'SoFCSelection' can be created with type = SoType.fromName("SoFCSelection") node = type.createInstance()

Adding and removing objects to/from the scenegraph

Adding new nodes to the scenegraph can be done this way. Take care of always adding a SoSeparator to contain the geometry, coordinates and material info of a same object. The following example adds a red line from (0,0,0) to (10,0,0):

from pivy import coin sg = Gui.ActiveDocument.ActiveView.getSceneGraph() co = coin.SoCoordinate3() pts = [[0,0,0],[10,0,0]] co.point.setValues(0,len(pts),pts) ma = coin.SoBaseColor() ma.rgb = (1,0,0) li = coin.SoLineSet() li.numVertices.setValue(2) no = coin.SoSeparator() no.addChild(co) no.addChild(ma) no.addChild(li) sg.addChild(no)

To remove it, simply issue:

sg.removeChild(no)

Adding custom widgets to the interface

You can create custom widgets with Qt designer, transform them into a python script, and then load them into the FreeCAD interface with PyQt4.

The python code produced by the Ui python compiler (the tool that converts qt-designer .ui files into python code) generally looks like this (it is simple, you can also code it directly in python):

class myWidget_Ui(object):

 def setupUi(self, myWidget):
   myWidget.setObjectName("my Nice New Widget")
   myWidget.resize(QtCore.QSize(QtCore.QRect(0,0,300,100).size()).expandedTo(myWidget.minimumSizeHint())) # sets size of the widget
   self.label = QtGui.QLabel(myWidget) # creates a label
   self.label.setGeometry(QtCore.QRect(50,50,200,24)) # sets its size
   self.label.setObjectName("label") # sets its name, so it can be found by name
 def retranslateUi(self, draftToolbar): # built-in QT function that manages translations of widgets
   myWidget.setWindowTitle(QtGui.QApplication.translate("myWidget", "My Widget", None, QtGui.QApplication.UnicodeUTF8))
   self.label.setText(QtGui.QApplication.translate("myWidget", "Welcome to my new widget!", None, QtGui.QApplication.UnicodeUTF8))				

Then, all you need to do is to create a reference to the FreeCAD Qt window, insert a custom widget into it, and "transform" this widget into yours with the Ui code we just made:

 app = QtGui.qApp
 FCmw = app.activeWindow() # the active qt window, = the freecad window since we are inside it
 myNewFreeCADWidget = QtGui.QDockWidget() # create a new dckwidget
 myNewFreeCADWidget.ui = myWidget_Ui() # load the Ui script
 myNewFreeCADWidget.ui.setupUi(myNewFreeCADWidget) # setup the ui
 FCmw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myNewFreeCADWidget) # add the widget to the main window